#include "scene.h"

#include "V3.h"
#include "M33.h"
#include "tm.h"

Scene *scene;

using namespace std;

#include <iostream>
#include <fstream>

Scene::Scene() {

	gui = new GUI();
	gui->show();

	int u0 = 16;
	int v0 = 40;
	int h = 480;
	int w = 640;
	fb = new FrameBuffer(u0, v0, w, h);
	fb->position(u0, v0);
	fb->label("SW framebuffer");
	fb->show();
	fb->SetBGR(0xFF0000FF);
	fb->redraw();
	float hfov = 60.0f;
	ppc = new PPC(hfov, w, h);

	gui->uiw->position(u0+w+u0, v0);

}

void Scene::DBG() {

	{
		V3 cc(0.0f, 0.0f, -100.0f);
		float cubeSideLength = 30.0f;
		TM tm;
		tm.SetAsAACube(cc, cubeSideLength);
//		fb->DrawTMVerts(tm);
		fb->redraw();
		return;
	}
	{
		V3 P(0.0f, 0.0f, -100.0f);
		V3 pP;
		ppc->Project(P, pP);
		cerr << pP << endl;
		return;
	}

	{

		fb->SetBGR(0xFF000000);
		fb->SaveAsTiff("mydbg/blackImage.tif");
		fb->SetBGR(0xFF00FF00);
		fb->redraw();
		Fl::check();
		char c;
		cin >> c;
		fb->LoadTiff("mydbg/redImage.tif");
		fb->redraw();
		return;
	}

	{

		V3 p0(20.0f, 430.0f, 0.0f);
		V3 p1(520.0f, 331.0f, 0.0f);
		fb->SetBGR(0xFFFFFFFF);
		fb->DrawSegment(p0, p1, 0xFF000000);
		fb->redraw();
		return;

	}

	{
		V3 tlc(100.5f, 45.5f, 0.0f);
		V3 brc(300.5f, 145.5f, 0.0f);
		unsigned int col = 0xFF0000FF;
		unsigned int colDisk = 0xFFFFFF00;
		V3 center(114.1f, 300.1f, 0.0f);
		float r = 110.0f;
		int fN = 1000;
		float du = 1.f;
		for (int fi = 0; fi < fN; fi++) {
			fb->SetBGR(0xFFFFFFFF);
			fb->DrawAARectangle(tlc, brc, col);
//			fb->DrawDisk(center, r, colDisk);
			fb->redraw();
			Fl::check();
			tlc[0] += du;
			brc[0] += du;
			center[0] += du;
		}
		return;
	}

	{
		M33 m;
		V3 v(1.0f, 2.0f, 3.0f);
		m[0] = v;
		m[1] = v;
		m[2] = v;
		V3 ret = m*v;
		cerr << "mv: " << ret << endl;
		return;
	}
	{
		V3 v(1.0f, 2.0f, 3.0f);
		cerr << "v: " << v << endl;
		return;
	}

	cerr << "INFO: pressed DBG button on GUI" << endl;

	{
		V3 v0(1.0f, 2.0f, 3.0f);
		V3 v1(-1.0f, -2.0f, -3.0f);
		V3 v01 = v0 + v1;
		cerr << "v0 + v1: " << v01[0] << " " << v01[1] << " " << v01[2] << endl;
		return;
	}

	return;

	unsigned int col0 = 0xFF000000;
	unsigned int col1 = 0xFFFFFFFF;
	int csize = 100;
	fb->SetChecker(col0, col1, csize);
	fb->redraw();
}

void Scene::NewButton() {
	cerr << "INFO: pressed New button on GUI" << endl;
}

